var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { KMS } from 'aws-sdk';
const kms = new KMS();
const isBase64 = /^([A-Za-z0-9+/]{4})*([A-Za-z0-9+/]{4}|[A-Za-z0-9+/]{3}=|[A-Za-z0-9+/]{2}==)$/;
export const dictionary = new Map();
function decrypt(ciphertext) {
    return __awaiter(this, void 0, void 0, function* () {
        const result = yield kms
            .decrypt({ CiphertextBlob: Buffer.from(ciphertext, 'base64') })
            .promise();
        const plaintext = result.Plaintext ? result.Plaintext.toString() : ciphertext;
        return dictionary.set(ciphertext, plaintext) && plaintext;
    });
}
export default (ciphertext) => (process.env.DISABLE_AWS_KMS_THINGY && ciphertext) ||
    (!isBase64.test(ciphertext) && ciphertext) ||
    dictionary.get(ciphertext) ||
    decrypt(ciphertext);
